<template>
  <div id="goods">
    <el-row>
      <el-col
        :span="24"
        class="main animate__animated animate__backInRight"
        v-loading="loadings"
        element-loading-text="拼命加载中"
        element-loading-spinner="el-icon-loading"
      >
        <span v-if="view === 'list'">
          <el-col :span="24">
            <el-col :span="2"><el-button type="primary" size="mini" @click="toBack()">返回</el-button></el-col>
          </el-col>
          <el-col :span="24" class="one"> <span>系统消息管理</span> </el-col>
          <el-col :span="24">
            <data-search :fields="searchFields" v-model="searchInfo" @query="search">
              <template #status>
                <el-option v-for="i in statusList" :key="i.label" :label="i.label" :value="i.value"></el-option>
              </template>
              <template #source>
                <el-option v-for="i in sourceList" :key="i.label" :label="i.label" :value="i.value"></el-option>
              </template>
            </data-search>
          </el-col>
          <el-col :span="24"> <data-btn :fields="btnList" @add="toAdd"></data-btn></el-col>
          <el-col :span="24">
            <data-table
              ref="dataTable"
              :fields="fields"
              :opera="opera"
              :data="list"
              :total="total"
              @query="search"
              @edit="toEdit"
              @delete="toDelete"
            ></data-table>
          </el-col>
        </span>
        <detail v-if="view === 'info'" :id="ids" @goBack="goBack"></detail>
      </el-col>
    </el-row>
  </div>
</template>

<script>
const _ = require('lodash');
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions: msgList } = createNamespacedHelpers('msgList');
const { mapActions: notice } = createNamespacedHelpers('notice');
const { mapActions: dictData } = createNamespacedHelpers('dictData'); // 字典

export default {
  name: 'index',
  props: { id: { type: String } },
  components: {
    detail: () => import('./detail.vue'),
  },
  data: function () {
    return {
      loadings: true,
      loading: false,
      view: 'list',
      fields: [
        { label: '用户', model: 'customer.name', showTip: false },
        { label: '发送时间', model: 'time' },
        { label: '来源id', model: 'source_id' },
        {
          label: '信息来源',
          model: 'source',
          format: (i) => {
            let data = this.sourceList.find((f) => f.value == i);
            if (data) return data.label;
            else return '暂无';
          },
        },
        {
          label: '状态',
          model: 'status',
          format: (i) => {
            let data = this.statusList.find((f) => f.value == i);
            if (data) return data.label;
            else return '暂无';
          },
        },
      ],
      opera: [
        { label: '修改', method: 'edit' },
        { label: '删除', method: 'delete', confirm: true, type: 'danger' },
      ],
      btnList: [{ label: '添加', method: 'add' }],
      searchFields: [
        { label: '状态', model: 'status', type: 'select' },
        { label: '信息来源', model: 'source', type: 'select' },
      ],
      searchInfo: {},
      list: [],
      total: 0,
      ids: '',
      // 状态
      statusList: [],
      // 信息来源
      sourceList: [],
    };
  },
  created() {
    this.searchOthers();

    this.search();
  },
  methods: {
    ...dictData({ dictQuery: 'query' }),
    ...notice(['query', 'delete', 'fetch', 'update', 'create']),
    ...msgList({ msgQuery: 'query' }),
    // 查询
    async search({ skip = 0, limit = this.$limit, ...others } = {}) {
      let query = { skip, limit, ...others };
      if (Object.keys(this.searchInfo).length > 0) query = { ...query, ...this.searchInfo };
      if (this.id) query.source_id = this.id;
      const res = await this.query(query);
      if (this.$checkRes(res)) {
        this.$set(this, `list`, res.data);
        this.$set(this, `total`, res.total);
      }
      this.loadings = false;
    },

    // 新增
    toAdd() {
      let id = '';
      this.$set(this, `ids`, id);
      this.$set(this, `view`, 'info');
    },
    // 修改
    async toEdit({ data }) {
      this.$set(this, `ids`, data._id);
      this.$set(this, `view`, 'info');
    },
    // 删除
    async toDelete({ data }) {
      let res = await this.delete(data._id);
      if (this.$checkRes(res)) {
        this.$message({ type: `success`, message: `刪除信息成功` });
        this.search();
      }
    },
    // 返回
    toBack(data) {
      this.$emit('toBack');
    },
    goBack() {
      this.view = 'list';
    },
    // 查询其他信息
    async searchOthers() {
      let res;
      res = await this.dictQuery({ code: 'notice_status' });
      if (this.$checkRes(res)) this.$set(this, `statusList`, res.data);
      // 信息来源
      res = await this.dictQuery({ code: 'notice_source' });
      if (this.$checkRes(res)) this.$set(this, `sourceList`, res.data);
    },
  },
  computed: {
    ...mapState(['user']),
  },
};
</script>

<style lang="less" scoped>
.main {
  .one {
    margin: 0 0 10px 0;

    span:nth-child(1) {
      font-size: 20px;
      font-weight: 700;
      margin-right: 10px;
    }
  }
  .two {
    margin: 0 0 10px 0;
  }
  .thr {
    margin: 0 0 10px 0;
  }
}
.el-col {
  margin: 10px 0;
}
</style>
